%define     gemdir      %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%define     gemname     ferret
%define     geminstdir  %{gemdir}/gems/%{gemname}-%{version}

%{!?ruby_sitearch:  %define ruby_sitearch   %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")}
%{!?ruby_sitelib:  %define ruby_sitelib   %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")}

Summary:        Full-featured text search engine library
Name:           rubygem-%{gemname}
Version:        0.11.6
Release:        9%{?dist}
Group:          Development/Languages
# License from
# - MIT-LICENSE: MIT
# - ext/posh.c: 3-clause BSD
# - ext/q_parser.c: GPLv2+
License:        MIT and BSD
URL:            http://rubyforge.org/projects/ferret/
Source0:        http://gems.rubyforge.org/gems/%{gemname}-%{version}.gem
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:       rubygems
Requires:       ruby(abi) = 1.8
BuildRequires:  rubygems
BuildRequires:  ruby-devel
BuildRequires:  rubygem(rake)
Provides:       rubygem(%{gemname}) = %{version}

%description
Ferret is a high-performance, full-featured text search
engine library written entirely in pure Ruby (with an
optional C extension). It is inspired by the Java Lucene
Project.

%package    doc
Summary:    Documentation for %{name}
Group:      Documentation
Requires:   %{name} = %{version}-%{release}

%description    doc
This package contains documentation for %{name}.

#%package devel
#Requires:       rubygem-%{gemname} = %{version}-%{release}
#Group:          Development/Languages
#Summary:        Development files for rubygem-ferret

#%description devel
#Ferret is a high-performance, full-featured text search
#engine library written entirely in pure Ruby (with an
#optional C extension). It is inspired by the Java Lucene
#Project. These are the devel files.

%prep
%setup -q -c -T

%build
mkdir -p ./%{gemdir}
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
gem install \
    --local \
    --install-dir ./%{gemdir} \
    -V --force \
    %{SOURCE0}

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gemdir}
cp -a ./%{gemdir}/* %{buildroot}%{gemdir}

install -d -m0755 %{buildroot}%{ruby_sitearch}
mv %{buildroot}%{geminstdir}/lib/ferret_ext.so %{buildroot}%{ruby_sitearch}

# You know ferret_ext.so needs to be 755 for find-debuginfo.sh to find it
chmod 0755 %{buildroot}%{ruby_sitearch}/ferret_ext.so

rm -rf %{buildroot}%{geminstdir}/ext
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}
rmdir %{buildroot}%{gemdir}/bin

%check
# Tests fail on ppc64, so make it fail softly
pushd .%{geminstdir}
rake test_units || :

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root, -)
%doc %{geminstdir}/CHANGELOG
%doc %{geminstdir}/MIT-LICENSE
%doc %{geminstdir}/README
%doc %{geminstdir}/TODO
%doc %{geminstdir}/TUTORIAL
%{_bindir}/ferret-browser
%dir %{geminstdir}
%{geminstdir}/lib
%{geminstdir}/bin
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec
%{ruby_sitearch}/ferret_ext.so

%files doc
%defattr(-,root,root,-)
%{gemdir}/doc/%{gemname}-%{version}/
%{geminstdir}/Rakefile
%{geminstdir}/setup.rb
%{geminstdir}/test/

%changelog
* Sun Apr 05 2009 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 0.11.6-9
- Update from comments in #468597
- Update to reflect new package guidelines

* Wed Oct 29 2008 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 0.11.6-7
- Adjust license tag for package (#468597)
- Adjust Source0 URL (#468597)
- Make sure that the gem installation dir itself is owned by this package (#468597)

* Sun Oct 25 2008 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 0.11.6-6
- Majorly revise packaging strategy (#468597)
- Found all licenses in each of the files
- Include license file

* Sun Oct 25 2008 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 0.11.6-2
- Better use of macros
- rpmlint now silent

* Sun Oct 25 2008 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 0.11.6-1
- Initial package
